/*
 * main.c
 *
 *  Created on: Nov 5, 2013
 *      Author: mtk
 */
#include <stdio.h>
#include "bst.h"

static void print_bst(bst* t);

int main(){

	bst tree;

	init_bst(&tree);

	insert(&tree,6);
	insert(&tree,3);
	insert(&tree,1);
	insert(&tree,4);
	insert(&tree,10);
	insert(&tree,8);
	insert(&tree,11);

	print_bst(&tree);


	printf("min: %d\n",minimum(&tree));
	printf("max: %d\n",maximum(&tree));

	int x = 11;
	printf("predecessor of %d: %d\n",x,predecessor(&tree,x));
	printf("successor of %d: %d\n",x,successor(&tree,x));

	return 0;
}

void print_bst_node(bst_node* n, int level){
	int i;
	if(n->left)
	print_bst_node(n->left,level+1);

	for(i=0; i<level; ++i) printf("    ");
	printf("%d\n",n->key);

	if(n->right)
	print_bst_node(n->right,level+1);
}

static void print_bst(bst* t){
	print_bst_node(t->root,0);
}
